<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XCallerFilterListMember StructType
 * @subpackage Structs
 */
class XCallerFilterListMember extends AbstractStructBase
{
    /**
     * The DnMask
     * Meta informations extracted from the WSDL
     * - documentation: Mandatory when "callerFilterMask" has value as Directory Number
     * - maxOccurs: 1
     * - minOccurs: 1
     * - maxLength: 50
     * @var string
     */
    public $DnMask;
    /**
     * The callerFilterMask
     * Meta informations extracted from the WSDL
     * - default: Directory Number
     * - documentation: Mandatory when value is a directory number
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $callerFilterMask;
    /**
     * Constructor method for XCallerFilterListMember
     * @uses XCallerFilterListMember::setDnMask()
     * @uses XCallerFilterListMember::setCallerFilterMask()
     * @param string $dnMask
     * @param string $callerFilterMask
     */
    public function __construct($dnMask = null, $callerFilterMask = 'Directory Number')
    {
        $this
            ->setDnMask($dnMask)
            ->setCallerFilterMask($callerFilterMask);
    }
    /**
     * Get DnMask value
     * @return string
     */
    public function getDnMask()
    {
        return $this->DnMask;
    }
    /**
     * Set DnMask value
     * @param string $dnMask
     * @return XCallerFilterListMember
     */
    public function setDnMask($dnMask = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($dnMask) && strlen($dnMask) > 50) || (is_array($dnMask) && count($dnMask) > 50)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 50 element(s) or a scalar of 50 character(s) at most, "%d" length given', is_scalar($dnMask) ? strlen($dnMask) : count($dnMask)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($dnMask) && !is_string($dnMask)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dnMask)), __LINE__);
        }
        $this->DnMask = $dnMask;
        return $this;
    }
    /**
     * Get callerFilterMask value
     * @return string
     */
    public function getCallerFilterMask()
    {
        return $this->callerFilterMask;
    }
    /**
     * Set callerFilterMask value
     * @uses XCallerFilterMask::valueIsValid()
     * @uses XCallerFilterMask::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $callerFilterMask
     * @return XCallerFilterListMember
     */
    public function setCallerFilterMask($callerFilterMask = 'Directory Number')
    {
        // validation for constraint: enumeration
        if (!XCallerFilterMask::valueIsValid($callerFilterMask)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $callerFilterMask, implode(', ', XCallerFilterMask::getValidValues())), __LINE__);
        }
        $this->callerFilterMask = $callerFilterMask;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return XCallerFilterListMember
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
